-----------------------------------------------------------------------------------------------
-- Client Lua Script for MyScanbotAndMe
-- Copyright (c) Aieny Celenovia. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
require "PlayerPathLib"
require "ChatSystemLib"

-----------------------------------------------------------------------------------------------
-- MyScanbotAndMe Module Definition
-----------------------------------------------------------------------------------------------
local MyScanbotAndMe = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function MyScanbotAndMe:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
    -- initialize variables here
	self.bIsActive = true

    return o
end

function MyScanbotAndMe:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- MyScanbotAndMe OnLoad
-----------------------------------------------------------------------------------------------
function MyScanbotAndMe:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("MyScanbotAndMe.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- MyScanbotAndMe OnDocLoaded
-----------------------------------------------------------------------------------------------
function MyScanbotAndMe:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "MyScanbotAndMeForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("msam", "OnSlashCommand", self)

		self.timer = nil

		-- Do additional Addon initialization here
		if (PlayerPathLib.GetPlayerPathType() == 2) then
			ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "MyScanbotAndMe is now active.  Use /msam to toggle.", "")
			self.timer = ApolloTimer.Create(15.000, true, "OnTrueTimer", self)
		end
	end
end

-----------------------------------------------------------------------------------------------
-- MyScanbotAndMe Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here
function MyScanbotAndMe:OnSlashCommand() 
	if (self.bIsActive) then 
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "MyScanbotAndMe is now disabled.", "")
		self.timer:Stop()
		self.bIsActive = false
	else
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "MyScanbotAndMe is now enabled.", "")
		self.timer:Start()
		self.bIsActive = true
	end
end	

-- on timer
function MyScanbotAndMe:OnTrueTimer() 
	if (self.bIsActive and not PlayerPathLib.ScientistHasScanBot()) then
		local scanbotProfile = PlayerPathLib.ScientistGetScanBotProfile()
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_Command, "Summoning " .. scanbotProfile.GetName(scanbotProfile), "")
		PlayerPathLib.ScientistToggleScanBot()
	end
end

-----------------------------------------------------------------------------------------------
-- MyScanbotAndMe Instance
-----------------------------------------------------------------------------------------------
local MyScanbotAndMeInst = MyScanbotAndMe:new()
MyScanbotAndMeInst:Init()
